-----------------------------------------------------------------------------------------------
-- Client Lua Script for QuitNow
-----------------------------------------------------------------------------------------------

local QuitNow = {} 
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function QuitNow:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 
    return o
end

function QuitNow:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- QuitNow OnLoad
-----------------------------------------------------------------------------------------------
function QuitNow:OnLoad()    
	Apollo.RegisterSlashCommand("quit", "OnSlashQuitNow", self)
	Apollo.RegisterSlashCommand("QUIT", "OnSlashQuitNow", self)
	Apollo.RegisterSlashCommand("q", "OnSlashQuitNow", self)
	Apollo.RegisterSlashCommand("exit", "OnSlashExitNow", self)
	Apollo.RegisterSlashCommand("EXIT", "OnSlashExitNow", self)
	Apollo.RegisterSlashCommand("e", "OnSlashExitNow", self)
	Apollo.RegisterSlashCommand("switch", "OnSlashSwitchNow", self)
	Apollo.RegisterSlashCommand("SWITCH", "OnSlashSwitchNow", self)
	Apollo.RegisterSlashCommand("logout", "OnSlashSwitchNow", self)
	Apollo.RegisterSlashCommand("LOGOUT", "OnSlashSwitchNow", self)
	Apollo.RegisterSlashCommand("home", "OnSlashHomeNow", self)
	Apollo.RegisterSlashCommand("HOME", "OnSlashHomeNow", self)
	Apollo.RegisterSlashCommand("h", "OnSlashHomeNow", self)
	Apollo.RegisterEventHandler("InterfaceMenuListHasLoaded", "OnInterfaceMenuListHasLoaded", self)
	Apollo.RegisterEventHandler("QuitNowInterfaceMenuClick", "OnQuitNowInterfaceMenuClick", self)
	Apollo.RegisterEventHandler("LogoutInterfaceMenuClick", "OnLogoutInterfaceMenuClick", self)
end




-----------------------------------------------------------------------------------------------
-- on SlashCommand "/quit"
function QuitNow:OnSlashQuitNow()
	ExitGame()
end

-- on SlashCommand "/exit"
function QuitNow:OnSlashExitNow()
	ExitGame()
	if ExitGame() then
		ExitNow()
	end
end

-- on SlashCommand "/switch" "/logout"
function QuitNow:OnSlashSwitchNow()
	Camp()
end

-- on SlashCommand "/home" / Credits to Quickblink
function QuitNow:OnSlashHomeNow()
	local cooldown = GameLib.GetSpell(38408):GetCooldownRemaining()
	if not HousingLib.IsResidenceOwner() then
		Print("You have no house!")
	elseif (cooldown and cooldown > 0) then
		if cooldown > 60 then
			Print("Teleport Home is in cooldown: "..string.format("%d", cooldown/60).."m")
		else
			Print("Teleport Home is in cooldown: "..string.format("%d", cooldown).."s")
		end
	end
end

function QuitNow:OnInterfaceMenuListHasLoaded()

	Event_FireGenericEvent("InterfaceMenuList_NewAddOn", "Quit game", {"QuitNowInterfaceMenuClick", "", ""})	
	Event_FireGenericEvent("InterfaceMenuList_NewAddOn", "Logout", {"LogoutInterfaceMenuClick", "", ""})	
	
end

function QuitNow:OnQuitNowInterfaceMenuClick() 
	Print("Exiting game")
	ExitGame()
end

function QuitNow:OnLogoutInterfaceMenuClick() 
	Print("Logging out")
	Camp()
end

function QuitNow:LogoutBtn() 
	Camp()
end
-----------------------------------------------------------------------------------------------
-- QuitNow Instance
-----------------------------------------------------------------------------------------------
local QuitNowInst = QuitNow:new()
QuitNowInst:Init()
